'From Squeak3.2gamma of 22 February 2002 [latest update: #4849] on 6 May 2002 at 2:57:10 pm'!
"Change Set:		fixObsRefs
Date:			6 May 2002
Author:			Michael Rueger

Removes references to obsolete classed from compiled methods and preference objects."!

!SystemDictionary methodsFor: 'housekeeping' stamp: 'mir 5/6/2002 14:54'!
fixObsoleteReferences
	"Smalltalk fixObsoleteReferences"
	| informee obsoleteBindings obsName realName realClass |
	Preference allInstances do: [:each | 
		informee _ each instVarNamed: #changeInformee.
		((informee isKindOf: Behavior)
			and: [informee isObsolete])
			ifTrue: [
				Transcript show: each name; cr.
				each instVarNamed: #changeInformee put: (Smalltalk at: (informee name copyReplaceAll: 'AnObsolete' with: '') asSymbol)]].
 
	CompiledMethod allInstances do: [:method |
		obsoleteBindings _ method literals select: [:literal |
			literal isVariableBinding
				and: [literal value isBehavior]
				and: [literal value isObsolete]].
		obsoleteBindings do: [:binding |
			obsName _ binding value name.
			Transcript show: obsName; cr.
			realName _ obsName copyReplaceAll: 'AnObsolete' with: ''.
			realClass _ Smalltalk at: realName asSymbol ifAbsent: [UndefinedObject].
			binding isSpecialWriteBinding
				ifTrue: [binding privateSetKey: binding key value: realClass]
				ifFalse: [binding key: binding key value: realClass]]].


	Behavior flushObsoleteSubclasses.
	Smalltalk garbageCollect; garbageCollect.
	Smalltalk obsoleteBehaviors size > 0
		ifTrue: [Smalltalk obsoleteBehaviors inspect]! !

"Postscript:
"
Smalltalk fixObsoleteReferences.
!

